#include "Matrix.h"
#include "Square.h"

using namespace std;

int main() {
    // Definisco una matrice identità di interi 3x3
    Matrix<int>* matrix = new Matrix<int>(3,3);
    
    // La stampo
    cout<<"Identita' 3x3"<<endl;
    cout<<matrix<<endl;
    
    // Cambio alcuni valori, metodo set
    matrix->set(0,0,3);
    matrix->set(1,1,3);
    matrix->set(2,2,3);
    cout<<matrix<<endl;
    
    // Cambio alcuni valori, operator overloading
    (*matrix)(0,0) = 8;
    cout<<matrix<<endl;
    
    // Stampo un valore
    cout<<"Il primo elemento e' "<<(*matrix)(0,0)<<endl;
    
    // Sommo due matrici
    Matrix<int>* matrix2 = new Matrix<int>(3,3);
    (*matrix2)(0,0) = 1;
    (*matrix2)(0,1) = 1;
    (*matrix2)(0,2) = 1;
    (*matrix2)(1,0) = 1;
    (*matrix2)(1,1) = 1;
    (*matrix2)(1,2) = 1;
    (*matrix2)(2,0) = 1;
    (*matrix2)(2,1) = 1;
    (*matrix2)(2,2) = 1;
    
    // metodo
    Printable* matrix3 = matrix->add(matrix2);
    cout<<"Somma (metodo)"<<endl<<matrix3<<endl;

    // operatore
    cout<<"Somma (operatore)"<<endl<<(Matrix<int>*)(*matrix+matrix2)<<endl;
    
    // Moltiplicazione per scalare
    Matrix<int>* matrix4 = matrix2->multiply(3);
    cout << matrix4  << endl;

    // Conversione a lista
    Matrix<int>* matrix5 = new Matrix<int>(5,5);
    list<int>* l = matrix5->toList();

    // Stampa lista
    list<int>::iterator i = l->begin();
    while(i!=l->end()){
        cout << *i << " ";
        i++;
    }
    cout<<endl;
    
    // Media
    cout<<"Media: "<<matrix5->getMean()<<endl;
    
    // Massimo
    cout<<"Massimo: "<<matrix5->getMax()<<endl;

    cout<<endl;
    
    // Applicazione di una funzione
    Square s;
    Matrix<int>* matrix6 = matrix2->multiply(3)->apply(s);
    cout<<matrix6;
    
    delete matrix;
    delete matrix2;
    delete matrix3;
    delete matrix4;
    delete matrix5;
    delete matrix6;
    
    return 0;
}
